<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.9.1"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Eddie: CoapServer Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Eddie
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.1 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pub-static-methods">Static Public Member Functions</a> &#124;
<a href="classCoapServer-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">CoapServer Class Reference</div>  </div>
</div><!--header-->
<div class="contents">
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:ad5149c00a7b9fde3bbaac8f36d2c89ee"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCoapServer.html#ad5149c00a7b9fde3bbaac8f36d2c89ee">CoapServer</a> (const char *host, const char *port)</td></tr>
<tr class="separator:ad5149c00a7b9fde3bbaac8f36d2c89ee"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5128aef62364279915b14a50205c1a68"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCoapServer.html#a5128aef62364279915b14a50205c1a68">~CoapServer</a> ()</td></tr>
<tr class="separator:a5128aef62364279915b14a50205c1a68"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5eb9e35199e0e9d72765ca4466cb6f13"><td class="memItemLeft" align="right" valign="top"><a class="el" href="classCoapClient.html">CoapClient</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCoapServer.html#a5eb9e35199e0e9d72765ca4466cb6f13">get_client</a> ()</td></tr>
<tr class="separator:a5eb9e35199e0e9d72765ca4466cb6f13"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af58cf02cfa2575c558e04fdffec4403c"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCoapServer.html#af58cf02cfa2575c558e04fdffec4403c">add_resource</a> (<a class="el" href="classEddieResource.html">EddieResource</a> *resource)</td></tr>
<tr class="separator:af58cf02cfa2575c558e04fdffec4403c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa03a8a20c841396f698a541e87da3b5e"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCoapServer.html#aa03a8a20c841396f698a541e87da3b5e">run</a> ()</td></tr>
<tr class="separator:aa03a8a20c841396f698a541e87da3b5e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5c7f9c829a2809bbcdd737618814c9fd"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCoapServer.html#a5c7f9c829a2809bbcdd737618814c9fd">start_server</a> ()</td></tr>
<tr class="separator:a5c7f9c829a2809bbcdd737618814c9fd"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5b8430f0776f3d81d559bf056164cbc2"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCoapServer.html#a5b8430f0776f3d81d559bf056164cbc2">stop_server</a> ()</td></tr>
<tr class="separator:a5b8430f0776f3d81d559bf056164cbc2"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a868d080db89c74cce694ec370b38c01e"><td class="memItemLeft" align="right" valign="top">const std::string &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCoapServer.html#a868d080db89c74cce694ec370b38c01e">get_my_ip</a> () const</td></tr>
<tr class="separator:a868d080db89c74cce694ec370b38c01e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a860496fc1f6bcfe099f486af92876094"><td class="memItemLeft" align="right" valign="top">const std::string &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCoapServer.html#a860496fc1f6bcfe099f486af92876094">get_my_port</a> () const</td></tr>
<tr class="separator:a860496fc1f6bcfe099f486af92876094"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af832d2ff6a571e8dd043f9de79f71d47"><td class="memItemLeft" align="right" valign="top">coap_context_t *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCoapServer.html#af832d2ff6a571e8dd043f9de79f71d47">get_context</a> () const</td></tr>
<tr class="separator:af832d2ff6a571e8dd043f9de79f71d47"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad6a18dddcb2e935b6d691f8fc3e2f067"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCoapServer.html#ad6a18dddcb2e935b6d691f8fc3e2f067">is_ipv6</a> () const</td></tr>
<tr class="separator:ad6a18dddcb2e935b6d691f8fc3e2f067"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-static-methods"></a>
Static Public Member Functions</h2></td></tr>
<tr class="memitem:ada9e1dc9ce93d16e4392ebe8ac3649f1"><td class="memItemLeft" align="right" valign="top">static std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCoapServer.html#ada9e1dc9ce93d16e4392ebe8ac3649f1">get_resources_in_linkformat</a> ()</td></tr>
<tr class="memdesc:ada9e1dc9ce93d16e4392ebe8ac3649f1"><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the resources added into the server in link format.  <a href="classCoapServer.html#ada9e1dc9ce93d16e4392ebe8ac3649f1">More...</a><br /></td></tr>
<tr class="separator:ada9e1dc9ce93d16e4392ebe8ac3649f1"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a id="ad5149c00a7b9fde3bbaac8f36d2c89ee"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ad5149c00a7b9fde3bbaac8f36d2c89ee">&#9670;&nbsp;</a></span>CoapServer()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">CoapServer::CoapServer </td>
          <td>(</td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>host</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>port</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">explicit</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p><a class="el" href="classCoapServer.html">CoapServer</a> constructor </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">host</td><td>The server's IP address. This IP address will used as base url in the resource directory registration </td></tr>
    <tr><td class="paramname">port</td><td>Port number of the server as a string </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a5128aef62364279915b14a50205c1a68"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a5128aef62364279915b14a50205c1a68">&#9670;&nbsp;</a></span>~CoapServer()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">CoapServer::~CoapServer </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>The <a class="el" href="classCoapServer.html">CoapServer</a> destructor unpublishes the resources previously registered in the resource directory, stops a potentially running server thread and releases resources. </p>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="af58cf02cfa2575c558e04fdffec4403c"></a>
<h2 class="memtitle"><span class="permalink"><a href="#af58cf02cfa2575c558e04fdffec4403c">&#9670;&nbsp;</a></span>add_resource()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int CoapServer::add_resource </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classEddieResource.html">EddieResource</a> *&#160;</td>
          <td class="paramname"><em>resource</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Add a resource into the server. A resource consists of a path, attributes and REST methods. Adding the resource allows the server to serve it and call the appropriate REST handler whenever it receives a request targeting the served resource. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">resource</td><td>An <a class="el" href="classEddieResource.html">EddieResource</a> object containing resource information (e.g. path and attributes) and REST handlers </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>0 on success, -1 on error </dd></dl>

</div>
</div>
<a id="a5eb9e35199e0e9d72765ca4466cb6f13"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a5eb9e35199e0e9d72765ca4466cb6f13">&#9670;&nbsp;</a></span>get_client()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classCoapClient.html">CoapClient</a>* CoapServer::get_client </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>The client is the object used to send CoAP requests </p><dl class="section return"><dt>Returns</dt><dd>The client object used by CoAP server for the communication </dd></dl>

</div>
</div>
<a id="af832d2ff6a571e8dd043f9de79f71d47"></a>
<h2 class="memtitle"><span class="permalink"><a href="#af832d2ff6a571e8dd043f9de79f71d47">&#9670;&nbsp;</a></span>get_context()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">coap_context_t* CoapServer::get_context </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Get server context </p><dl class="section return"><dt>Returns</dt><dd>The context of the server </dd></dl>

</div>
</div>
<a id="a868d080db89c74cce694ec370b38c01e"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a868d080db89c74cce694ec370b38c01e">&#9670;&nbsp;</a></span>get_my_ip()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">const std::string&amp; CoapServer::get_my_ip </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Get IP address assigned to the server, this address is used as base url in the resource directory registration </p><dl class="section return"><dt>Returns</dt><dd>The server's IP address. </dd></dl>

</div>
</div>
<a id="a860496fc1f6bcfe099f486af92876094"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a860496fc1f6bcfe099f486af92876094">&#9670;&nbsp;</a></span>get_my_port()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">const std::string&amp; CoapServer::get_my_port </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Get port number assigned to the server </p><dl class="section return"><dt>Returns</dt><dd>Port number of the server as a string </dd></dl>

</div>
</div>
<a id="ada9e1dc9ce93d16e4392ebe8ac3649f1"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ada9e1dc9ce93d16e4392ebe8ac3649f1">&#9670;&nbsp;</a></span>get_resources_in_linkformat()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static std::string CoapServer::get_resources_in_linkformat </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Get the resources added into the server in link format. </p>
<dl class="section return"><dt>Returns</dt><dd>resources as a link format string </dd></dl>

</div>
</div>
<a id="ad6a18dddcb2e935b6d691f8fc3e2f067"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ad6a18dddcb2e935b6d691f8fc3e2f067">&#9670;&nbsp;</a></span>is_ipv6()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool CoapServer::is_ipv6 </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Check if the assigned IP address is IPv6 or IPv4 </p><dl class="section return"><dt>Returns</dt><dd>True if the assigned IP address is IPv6, False otherwise. </dd></dl>

</div>
</div>
<a id="aa03a8a20c841396f698a541e87da3b5e"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aa03a8a20c841396f698a541e87da3b5e">&#9670;&nbsp;</a></span>run()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int CoapServer::run </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Run the server loop spinning the CoAP I/O processing function. This loop runs until set_quit(true) is called </p><dl class="section return"><dt>Returns</dt><dd>0 on success, negative integer on failure. </dd></dl>

</div>
</div>
<a id="a5c7f9c829a2809bbcdd737618814c9fd"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a5c7f9c829a2809bbcdd737618814c9fd">&#9670;&nbsp;</a></span>start_server()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int CoapServer::start_server </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Start the server loop in a separate thread without blocking. </p><dl class="section return"><dt>Returns</dt><dd>0 on success, negative integer on failure. </dd></dl>

</div>
</div>
<a id="a5b8430f0776f3d81d559bf056164cbc2"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a5b8430f0776f3d81d559bf056164cbc2">&#9670;&nbsp;</a></span>stop_server()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int CoapServer::stop_server </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Stop the server thread </p><dl class="section return"><dt>Returns</dt><dd>0 on success, negative integer on failure. </dd></dl>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li>/builds/eclipse/oniro-core/eddie/linux/communication/include/<a class="el" href="CoapServer_8h_source.html">CoapServer.h</a></li>
</ul>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.1
</small></address>
</body>
</html>
